// pimgwrap.cpp : Defines the entry point for the application.
//

#include "stdafx.h"

#define PIMG_FILE_PATH		_T("\\Windows\\pimg.exe")
#define PIMG_REGKEY_NAME	_T("Software\\Microsoft\\Pictures")
#define PIMG_LASTLOCATION_VALUE_NAME	_T("LastLocation")
#define PIMG_LOCALPATH_VALUE_NAME		_T("LocalPath")
#define PIMG_STORAGECARDPATH_VALUE_NAME	_T("StorageCardPath")
#define PIMG_DIRECTORY_OPTION			_T("-directory:")



int WINAPI WinMain(	HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
					LPTSTR    lpCmdLine,
					int       nCmdShow)
{
 	
	HKEY	hKey = NULL;
	BOOL	bRet;
	BOOL	bGetDirectory;
	LONG	lResult;
	DWORD	dwSize;
	DWORD	dwType;
	DWORD	dwLocation;
	TCHAR	szDirectory[MAX_PATH + 1];
	TCHAR	szOption[MAX_PATH + 1];
	PROCESS_INFORMATION	pi;

	bGetDirectory = FALSE;	// WXgfBNgpXǂݍ߂H

	lResult = RegOpenKeyEx(HKEY_CURRENT_USER, PIMG_REGKEY_NAME, 0, 0, &hKey);
	if (lResult == ERROR_SUCCESS) {

		dwType = REG_DWORD;
		dwSize = sizeof(dwLocation);
		lResult = RegQueryValueEx(hKey, PIMG_LASTLOCATION_VALUE_NAME, 0, &dwType, (LPBYTE)&dwLocation, &dwSize);

		if (lResult == ERROR_SUCCESS) {
			switch(dwLocation) {
			case 0:
				dwType = REG_SZ;
				dwSize = sizeof(szDirectory);
				memset(szDirectory, 0, sizeof(szDirectory));
				lResult = RegQueryValueEx(hKey, PIMG_LOCALPATH_VALUE_NAME, 0, &dwType, (LPBYTE)szDirectory, &dwSize);
				if (lResult == ERROR_SUCCESS) {
					bGetDirectory = TRUE;
				}
				break;
			case 1:
				dwType = REG_SZ;
				dwSize = sizeof(szDirectory);
				memset(szDirectory, 0, sizeof(szDirectory));
				lResult = RegQueryValueEx(hKey, PIMG_STORAGECARDPATH_VALUE_NAME, 0, &dwType, (LPBYTE)szDirectory, &dwSize);
				if (lResult == ERROR_SUCCESS) {
					bGetDirectory = TRUE;
				}
				break;
			default:
				break;
			}
		}

		RegCloseKey(hKey);
		hKey = NULL;
	}

	if (bGetDirectory) {

		wsprintf(szOption, TEXT("%s%s"), PIMG_DIRECTORY_OPTION, szDirectory);

		memset(&pi, 0, sizeof(pi));
		bRet = CreateProcess(PIMG_FILE_PATH, szOption, NULL, NULL, FALSE, 0, NULL, NULL, NULL, &pi);
		if (bRet) {
			CloseHandle(pi.hThread);
			CloseHandle(pi.hProcess);
		}
	}
	else {
		memset(&pi, 0, sizeof(pi));
		bRet = CreateProcess(PIMG_FILE_PATH, NULL, NULL, NULL, FALSE, 0, NULL, NULL, NULL, &pi);
		if (bRet) {
			CloseHandle(pi.hThread);
			CloseHandle(pi.hProcess);
		}
	}

	return 0;
}
